package zall.action.media;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import zall.action.ZalleryAction;
import zall.bean.Media;
import zall.bean.User;
import zall.manager.AuthenticationManager;
import zutil.db.DBConnection;
import zutil.ui.UserMessageManager;
import zutil.ui.UserMessageManager.MessageLevel;
import zutil.ui.UserMessageManager.UserMessage;

public class RemoveMediaAction extends ZalleryAction {

    public RemoveMediaAction() {
        super("rmmedia", true);
    }

    @Override
    public void handleRequest(DBConnection db, HttpServletRequest request, HttpServletResponse response, HttpSession session,
                              PrintWriter out, User user, UserMessageManager msgs) throws SQLException, IOException {

        // Remove media
        if (request.getParameter("id") == null || request.getParameter("type") == null) {
            msgs.add(new UserMessage(MessageLevel.ERROR, "Missing parameters!"));
            return;
        }
        long id = Long.parseLong(request.getParameter("id"));
        Media media = Media.load(db, request.getParameter("type"), id);

        if (media != null) {
            if (AuthenticationManager.canEdit(user, media)) {
                media.delete(db);

                msgs.add(new UserMessage(MessageLevel.INFO, "Item removed successfully."));
            } else
                msgs.add(new UserMessage(MessageLevel.ERROR, "You are not authorize to delete the item!"));
        } else
            msgs.add(new UserMessage(MessageLevel.ERROR, "The item does not exist!"));

    }

}
